#!/bin/sh

cd `dirname $0`

VersionKernel=`uname -r`
FicModulesDep=/lib/modules/$VersionKernel/modules.dep

[ -e /etc/conf.modules ] && FicModules=/etc/conf.modules
[ -e /etc/modules.conf ] && FicModules=/etc/modules.conf

# Pour les tests
#FicModules=/tmp/modules.conf

#
# Quelle est la carte son ?
#

./scan-pci.sh sndlist -v
CarteSon=`cat /tmp/scan-pci`
echo "$CarteSon" | grep "\.o$" > /dev/null && \
CarteSon=`echo $CarteSon | sed "s/\.o$//"`

#case "`uname -r`" in
#    2.2.*) ;;
#    2.4.*) CarteSon=`echo $CarteSon | sed "s/card-//"` ;;
#    *) echo >&2 "Version du kernel non supportee" ; exit 1 ;;
#esac

case `amixer -v 2> /dev/null | cut -d " " -f3` in
    0.9*) CarteSon=`echo $CarteSon | sed "s/card-//"` ;;
esac

#[ ! -f /lib/modules/$VersionKernel/misc/$CarteSon.o ] && echo >&2 "Module $CarteSon non compile" && exit 1

#
# Mise a jour du fichier des options de modules
#

[ "`uname -r | cut -d. -f2`" -ge 2 ] && SoundCore=soundcore || SoundCore=snd

sed "/# --- BEGIN: Generated by conf-sound.sh on/,/# --- END: Generated by conf-sound.sh ---/d" < $FicModules > $FicModules.old

cat << EOF >> $FicModules.old
# --- BEGIN: Generated by conf-sound.sh on `date` ---

alias char-major-116 snd
alias snd-card-0 $CarteSon
alias char-major-14 $SoundCore
alias sound-slot-0 snd-card-0
alias sound-service-0-0 snd-mixer-oss
alias sound-service-0-1 snd-seq-oss
alias sound-service-0-3 snd-pcm-oss
alias sound-service-0-8 snd-seq-oss
alias sound-service-0-12 snd-pcm-oss
options snd snd_major=116 snd_cards_limit=1\
 snd_device_mode=0666 snd_device_gid=0 snd_device_uid=0
post-install snd  alsactl restore

# --- END: Generated by conf-sound.sh ---
EOF

mv -f $FicModules.old $FicModules

#
# Chargement des modules (si insmod ne marche pas...)
#

[ ! -f /lib/modules/$VersionKernel/modules.dep ] && echo "Fichier /lib/modules/$VersionKernel/modules.dep n'existe pas" && exit 1

cat /lib/modules/$VersionKernel/modules.dep | while read ligne
do
    echo "$ligne" >> /tmp/modules.dep
done
FicModulesDep=/tmp/modules.dep

CopieModule()
{
    local Mod module
    module=$1
    echo "$module" | grep "/" > /dev/null || module=`grep "$module.o:" /lib/modules/$VersionKernel/modules.dep | cut -d: -f1 | sed -e "s;/lib/modules/$VersionKernel/;;"`
    echo "$module" | grep "\.o$" > /dev/null && module=`echo $module | sed "s/\.o$//"`
    Dep=`grep "$module.o:" $FicModulesDep`
    Dep=`echo $Dep | sed "s/.*://"`

    for ModDep in $Dep
    do
        ModDep=`echo $ModDep | sed -e "s;/lib/modules/$VersionKernel/;;" \
                                   -e "s/\.o//"`
        CopieModule $ModDep
    done
    Mod=`basename $module`
    grep "^$Mod" /tmp/snd.$$ > /dev/null || echo "insmod /lib/modules/$VersionKernel/$module.o"
    echo "$Mod" >> /tmp/snd.$$
}

touch /tmp/snd.$$

rm -f /etc/init.d/alsasound.start
CopieModule snd-pcm-oss >> /etc/init.d/alsasound.start
CopieModule $CarteSon  >> /etc/init.d/alsasound.start
rm -f /tmp/snd.$$
rm -f /tmp/modules.dep

chmod +x /etc/init.d/alsasound.start
/etc/init.d/alsasound.start

#
# Le volume de la carte son
#

! amixer set Master 80% unmute && echo >&2 "Card not detected correctly -exit." && exit 1
amixer set PCM 100% unmute
# ESS 1969 chipset has 2 PCM channels
amixer set PCM,1 100% unmute 2>/dev/null
# Trident chipsets have also Wave group on digital path:
amixer set Wave 100% unmute 2>/dev/null
# CS4237B chipset:
amixer set 'Master Digital' 80% unmute 2>/dev/null
# for some GUS soundcards
amixer set Synth 50% unmute 2>/dev/null

#
# Pour la prochaine fois
#

alsactl store

